var __defProp = Object.defineProperty;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
import { defineComponent, toRefs, computed, createVNode, resolveDynamicComponent, mergeProps, watch, onUnmounted, Transition, ref, unref, nextTick, withModifiers, inject, h, render, withDirectives, resolveDirective, renderSlot, useSlots, reactive, getCurrentInstance, onMounted, provide, toRef, vShow, Teleport, isVNode } from "vue";
import { onClickOutside } from "@vueuse/core";
import { offset, autoPlacement, arrow, shift, computePosition } from "@floating-ui/dom";
const editableSelectProps = {
  modelValue: {
    type: [String, Number]
  },
  appendToBody: {
    type: Boolean,
    default: false
  },
  position: {
    type: Array,
    default: ["bottom"]
  },
  options: {
    type: Array,
    default: () => []
  },
  width: {
    type: Number
  },
  maxHeight: {
    type: Number
  },
  size: {
    type: String
  },
  placeholder: {
    type: String,
    default: "Select"
  },
  loading: {
    type: Boolean,
    default: false
  },
  allowClear: {
    type: Boolean,
    default: false
  },
  disabled: {
    type: Boolean,
    default: false
  },
  disabledKey: {
    type: String,
    default: ""
  },
  remote: {
    type: Boolean,
    default: false
  },
  filterMethod: {
    type: Function
  },
  remoteMethod: {
    type: Function
  },
  enableLazyLoad: {
    type: Boolean,
    default: false
  }
};
const SELECT_KEY = Symbol("EditableSelect");
const DEFAULT_PREFIX = "icon";
const iconProps = {
  name: {
    type: String,
    default: "",
    required: true
  },
  size: {
    type: [Number, String],
    default: "inherit"
  },
  color: {
    type: String,
    default: "inherit"
  },
  component: {
    type: Object,
    default: null
  },
  classPrefix: {
    type: String,
    default: DEFAULT_PREFIX
  },
  operable: {
    type: Boolean,
    default: false
  },
  disabled: {
    type: Boolean,
    default: false
  },
  rotate: {
    type: [Number, String]
  }
};
const svgIconProps = {
  name: {
    type: String,
    default: "",
    required: true
  },
  color: {
    type: String,
    default: "inherit"
  },
  size: {
    type: [Number, String],
    default: "inherit"
  }
};
function createBem(namespace, element, modifier) {
  let cls = namespace;
  if (element) {
    cls += `__${element}`;
  }
  if (modifier) {
    cls += `--${modifier}`;
  }
  return cls;
}
function useNamespace(block, needDot = false) {
  const namespace = needDot ? `.devui-${block}` : `devui-${block}`;
  const b = () => createBem(namespace);
  const e = (element) => element ? createBem(namespace, element) : "";
  const m = (modifier) => modifier ? createBem(namespace, "", modifier) : "";
  const em = (element, modifier) => element && modifier ? createBem(namespace, element, modifier) : "";
  return {
    b,
    e,
    m,
    em
  };
}
var icon = "";
var svgIcon = defineComponent({
  name: "DSvgIcon",
  props: svgIconProps,
  setup(props) {
    const {
      name,
      color,
      size
    } = toRefs(props);
    const ns = useNamespace("svg-icon");
    const iconName = computed(() => `#icon-${name.value}`);
    const iconSize = computed(() => {
      return typeof size.value === "number" ? `${size.value}px` : size.value;
    });
    const styles = {
      width: iconSize.value,
      height: iconSize.value
    };
    return () => {
      return createVNode("svg", {
        "class": ns.b(),
        "style": styles
      }, [createVNode("use", {
        "xlink:href": iconName.value,
        "fill": color.value
      }, null)]);
    };
  }
});
function isUrl(value) {
  return /^((http|https):)?\/\//.test(value);
}
function useIconDom(props, ctx) {
  const {
    component,
    name,
    size,
    color,
    classPrefix,
    rotate
  } = toRefs(props);
  const ns = useNamespace("icon");
  const iconSize = computed(() => {
    return typeof size.value === "number" ? `${size.value}px` : size.value;
  });
  const IconComponent = component.value ? resolveDynamicComponent(component.value) : resolveDynamicComponent(svgIcon);
  const imgIconDom = () => {
    return createVNode("img", mergeProps({
      "src": name.value,
      "alt": name.value.split("/")[name.value.split("/").length - 1],
      "class": [(rotate == null ? void 0 : rotate.value) === "infinite" && ns.m("spin")],
      "style": {
        width: iconSize.value || "",
        transform: `rotate(${rotate == null ? void 0 : rotate.value}deg)`,
        verticalAlign: "middle"
      }
    }, ctx.attrs), null);
  };
  const svgIconDom = () => {
    return createVNode(IconComponent, mergeProps({
      "name": name.value,
      "color": color.value,
      "size": iconSize.value,
      "class": [(rotate == null ? void 0 : rotate.value) === "infinite" && ns.m("spin")],
      "style": {
        transform: `rotate(${rotate == null ? void 0 : rotate.value}deg)`
      }
    }, ctx.attrs), null);
  };
  const fontIconDom = () => {
    const fontIconClass = /^icon-/.test(name.value) ? name.value : `${classPrefix.value}-${name.value}`;
    return createVNode("i", mergeProps({
      "class": [classPrefix.value, fontIconClass, (rotate == null ? void 0 : rotate.value) === "infinite" && ns.m("spin")],
      "style": {
        fontSize: iconSize.value,
        color: color.value,
        transform: `rotate(${rotate == null ? void 0 : rotate.value}deg)`
      }
    }, ctx.attrs), null);
  };
  const iconDom = () => {
    return component.value ? svgIconDom() : isUrl(name.value) ? imgIconDom() : fontIconDom();
  };
  return {
    iconDom
  };
}
var Icon = defineComponent({
  name: "DIcon",
  props: iconProps,
  emits: ["click"],
  setup(props, ctx) {
    const {
      disabled,
      operable
    } = toRefs(props);
    const {
      iconDom
    } = useIconDom(props, ctx);
    const ns = useNamespace("icon");
    const wrapClassed = computed(() => ({
      [ns.e("container")]: true,
      [ns.m("disabled")]: disabled.value,
      [ns.m("operable")]: operable.value,
      [ns.m("no-slots")]: !Object.keys(ctx.slots).length
    }));
    const onClick = (e) => {
      if (disabled.value) {
        return;
      }
      ctx.emit("click", e);
    };
    return () => {
      var _a, _b, _c, _d;
      return createVNode("div", {
        "class": wrapClassed.value,
        "onClick": onClick
      }, [(_b = (_a = ctx.slots).prefix) == null ? void 0 : _b.call(_a), iconDom(), (_d = (_c = ctx.slots).suffix) == null ? void 0 : _d.call(_c)]);
    };
  }
});
const fixedOverlayProps = {
  modelValue: {
    type: Boolean,
    default: false
  },
  lockScroll: {
    type: Boolean,
    default: true
  },
  closeOnClickOverlay: {
    type: Boolean,
    default: true
  }
};
function lockScroll() {
  if (document.documentElement.scrollHeight > document.documentElement.clientHeight) {
    const scrollTop = document.documentElement.scrollTop;
    const style = document.documentElement.getAttribute("style");
    document.documentElement.style.position = "fixed";
    document.documentElement.style.top = `-${scrollTop}px`;
    document.documentElement.style.width = document.documentElement.style.width || "100%";
    document.documentElement.style.overflowY = "scroll";
    return () => {
      if (style) {
        document.documentElement.setAttribute("style", style);
      } else {
        document.documentElement.removeAttribute("style");
      }
      document.documentElement.scrollTop = scrollTop;
    };
  }
  return;
}
function useFixedOverlay(props, ctx) {
  let lockScrollCb;
  const onClick = (event) => {
    event.preventDefault();
    ctx.emit("click", event);
    if (props.closeOnClickOverlay) {
      ctx.emit("update:modelValue", false);
    }
  };
  const removeBodyAdditions = () => {
    lockScrollCb == null ? void 0 : lockScrollCb();
  };
  watch(() => props.modelValue, (val) => {
    if (val) {
      props.lockScroll && (lockScrollCb = lockScroll());
    } else {
      removeBodyAdditions();
    }
  });
  onUnmounted(removeBodyAdditions);
  return { onClick };
}
var fixedOverlay = "";
defineComponent({
  name: "DFixedOverlay",
  inheritAttrs: false,
  props: fixedOverlayProps,
  emits: ["update:modelValue", "click"],
  setup(props, ctx) {
    const {
      modelValue
    } = toRefs(props);
    const ns = useNamespace("fixed-overlay");
    const {
      onClick
    } = useFixedOverlay(props, ctx);
    return () => createVNode(Transition, {
      "name": ns.m("fade")
    }, {
      default: () => {
        var _a, _b;
        return [modelValue.value && createVNode("div", mergeProps({
          "class": ns.b()
        }, ctx.attrs, {
          "onClick": onClick
        }), [(_b = (_a = ctx.slots).default) == null ? void 0 : _b.call(_a)])];
      }
    });
  }
});
const flexibleOverlayProps = {
  modelValue: {
    type: Boolean,
    default: false
  },
  origin: {
    type: Object,
    require: true
  },
  position: {
    type: Array,
    default: ["bottom"]
  },
  offset: {
    type: [Number, Object],
    default: 8
  },
  shiftOffset: {
    type: Number
  },
  align: {
    type: String,
    default: null
  },
  showArrow: {
    type: Boolean,
    default: false
  },
  isArrowCenter: {
    type: Boolean,
    default: true
  },
  clickEventBubble: {
    type: Boolean,
    default: false
  }
};
function getScrollParent(element) {
  const overflowRegex = /(auto|scroll|hidden)/;
  for (let parent = element; parent = parent.parentElement; parent.parentElement !== document.body) {
    const style = window.getComputedStyle(parent);
    if (overflowRegex.test(style.overflow + style.overflowX + style.overflowY)) {
      return parent;
    }
  }
  return window;
}
function adjustArrowPosition(isArrowCenter, point, placement, originRect) {
  let { x, y } = point;
  if (!isArrowCenter) {
    const { width, height } = originRect;
    if (x && placement.includes("start")) {
      x = 12;
    }
    if (x && placement.includes("end")) {
      x = Math.round(width - 24);
    }
    if (y && placement.includes("start")) {
      y = 10;
    }
    if (y && placement.includes("end")) {
      y = height - 14;
    }
  }
  return { x, y };
}
function useOverlay(props, emit) {
  const overlayRef = ref();
  const arrowRef = ref();
  let originParent = null;
  const updateArrowPosition = (arrowEl, placement, point, overlayEl) => {
    const { x, y } = adjustArrowPosition(props.isArrowCenter, point, placement, overlayEl.getBoundingClientRect());
    const staticSide = {
      top: "bottom",
      right: "left",
      bottom: "top",
      left: "right"
    }[placement.split("-")[0]];
    Object.assign(arrowEl.style, {
      left: x ? `${x}px` : "",
      top: y ? `${y}px` : "",
      right: "",
      bottom: "",
      [staticSide]: "-4px"
    });
  };
  const updatePosition = async () => {
    const hostEl = props.origin;
    const overlayEl = unref(overlayRef.value);
    const arrowEl = unref(arrowRef.value);
    const middleware = [
      offset(props.offset),
      autoPlacement({
        alignment: props.align,
        allowedPlacements: props.position
      })
    ];
    props.showArrow && middleware.push(arrow({ element: arrowEl }));
    props.shiftOffset !== void 0 && middleware.push(shift());
    const { x, y, placement, middlewareData } = await computePosition(hostEl, overlayEl, {
      strategy: "fixed",
      middleware
    });
    let applyX = x;
    let applyY = y;
    if (props.shiftOffset !== void 0) {
      const { x: shiftX, y: shiftY } = middlewareData.shift;
      shiftX < 0 && (applyX -= props.shiftOffset);
      shiftX > 0 && (applyX += props.shiftOffset);
      shiftY < 0 && (applyY -= props.shiftOffset);
      shiftY > 0 && (applyY += props.shiftOffset);
    }
    emit("positionChange", placement);
    Object.assign(overlayEl.style, { top: `${applyY}px`, left: `${applyX}px` });
    props.showArrow && updateArrowPosition(arrowEl, placement, middlewareData.arrow, overlayEl);
  };
  watch(() => props.modelValue, () => {
    if (props.modelValue && props.origin) {
      originParent = getScrollParent(props.origin);
      nextTick(updatePosition);
      originParent == null ? void 0 : originParent.addEventListener("scroll", updatePosition);
      originParent !== window && window.addEventListener("scroll", updatePosition);
      window.addEventListener("resize", updatePosition);
    } else {
      originParent == null ? void 0 : originParent.removeEventListener("scroll", updatePosition);
      originParent !== window && window.removeEventListener("scroll", updatePosition);
      window.removeEventListener("resize", updatePosition);
    }
  });
  onUnmounted(() => {
    originParent == null ? void 0 : originParent.removeEventListener("scroll", updatePosition);
    originParent !== window && window.removeEventListener("scroll", updatePosition);
    window.removeEventListener("resize", updatePosition);
  });
  return { arrowRef, overlayRef, updatePosition };
}
var flexibleOverlay = "";
const FlexibleOverlay = defineComponent({
  name: "DFlexibleOverlay",
  inheritAttrs: false,
  props: flexibleOverlayProps,
  emits: ["update:modelValue", "positionChange"],
  setup(props, {
    slots,
    attrs,
    emit,
    expose
  }) {
    const ns = useNamespace("flexible-overlay");
    const {
      clickEventBubble
    } = toRefs(props);
    const {
      arrowRef,
      overlayRef,
      updatePosition
    } = useOverlay(props, emit);
    expose({
      updatePosition
    });
    return () => {
      var _a;
      return props.modelValue && createVNode("div", mergeProps({
        "ref": overlayRef,
        "class": ns.b()
      }, attrs, {
        "onClick": withModifiers(() => ({}), [clickEventBubble.value ? "" : "stop"]),
        "onPointerup": withModifiers(() => ({}), ["stop"])
      }), [(_a = slots.default) == null ? void 0 : _a.call(slots), props.showArrow && createVNode("div", {
        "ref": arrowRef,
        "class": ns.e("arrow")
      }, null)]);
    };
  }
});
const dropdownProps = {
  options: {
    type: Array,
    default: () => []
  },
  width: {
    type: Number
  },
  maxHeight: {
    type: Number
  }
};
const editableSelectOptionProps = {
  label: {
    type: String
  },
  value: {
    type: [String, Number]
  },
  disabled: {
    type: Boolean,
    default: false
  },
  hovering: {
    type: Boolean,
    default: false
  }
};
function useOption(props) {
  const ns = useNamespace("editable-select");
  const select = inject(SELECT_KEY);
  const { disabled, hovering } = toRefs(props);
  const isSelected = computed(() => {
    var _a;
    return ((_a = select == null ? void 0 : select.modelValue) == null ? void 0 : _a.value) === props.value;
  });
  const optionClasses = computed(() => ({
    [ns.e("item")]: true,
    [ns.em("item", "selected")]: isSelected.value,
    [ns.em("item", "disabled")]: disabled.value,
    [ns.em("item", "hover")]: hovering.value,
    [ns.em("item", "no-data-tip")]: !(props.label || props.value)
  }));
  return { optionClasses };
}
var Option = defineComponent({
  name: "DEditableSelectOption",
  props: editableSelectOptionProps,
  emits: ["select"],
  setup(props, ctx) {
    const {
      optionClasses
    } = useOption(props);
    const currentLabel = computed(() => props.label || props.value);
    const handleClick = () => {
      if (!props.disabled) {
        ctx.emit("select");
      }
    };
    return () => {
      return createVNode("li", {
        "class": optionClasses.value,
        "onClick": handleClick
      }, [ctx.slots.default ? ctx.slots.default() : currentLabel.value]);
    };
  }
});
class View {
  constructor() {
    __publicField(this, "top", "50%");
    __publicField(this, "left", "50%");
  }
}
const loadingProps = {
  message: String,
  backdrop: Boolean,
  view: {
    type: Object,
    default: () => new View()
  },
  zIndex: Number,
  isFull: {
    type: Boolean,
    default: false
  }
};
class LoadingOptions {
  constructor() {
    __publicField(this, "target");
    __publicField(this, "message");
    __publicField(this, "loadingTemplateRef");
    __publicField(this, "backdrop", true);
    __publicField(this, "positionType", "relative");
    __publicField(this, "view", new View());
    __publicField(this, "zIndex");
  }
}
var loading = "";
var Loading = defineComponent({
  name: "Loading",
  inheritAttrs: false,
  props: loadingProps,
  setup(props) {
    const style = {
      top: props.view.top,
      left: props.view.left,
      zIndex: props.zIndex
    };
    if (!props.message) {
      style.background = "none";
    }
    const isShow = ref(false);
    const open = () => {
      isShow.value = true;
    };
    const close = () => {
      isShow.value = false;
    };
    return {
      style,
      isShow,
      open,
      close
    };
  },
  render() {
    var _a;
    const {
      isShow,
      isFull,
      backdrop,
      style,
      message,
      $slots
    } = this;
    const ns = useNamespace("loading");
    return isShow && createVNode("div", {
      "class": [ns.b(), isFull ? ns.m("full") : ""]
    }, [((_a = $slots.default) == null ? void 0 : _a.call($slots)) || createVNode("div", {
      "class": ns.e("wrapper")
    }, [backdrop ? createVNode("div", {
      "class": ns.e("mask")
    }, null) : null, createVNode("div", {
      "style": style,
      "class": ns.e("area")
    }, [createVNode("div", {
      "class": ns.e("busy-default-spinner")
    }, [createVNode("div", {
      "class": ns.e("bar1")
    }, null), createVNode("div", {
      "class": ns.e("bar2")
    }, null), createVNode("div", {
      "class": ns.e("bar3")
    }, null), createVNode("div", {
      "class": ns.e("bar4")
    }, null)]), message ? createVNode("span", {
      "class": ns.e("text")
    }, [message]) : null])])]);
  }
});
const COMPONENT_CONTAINER_SYMBOL = Symbol("dev_component_container");
function createComponent(component, props, children = null) {
  const vnode = h(component, __spreadValues({}, props), children);
  const container = document.createElement("div");
  vnode[COMPONENT_CONTAINER_SYMBOL] = container;
  render(vnode, container);
  return vnode.component;
}
function unmountComponent(ComponnetInstance) {
  render(null, ComponnetInstance == null ? void 0 : ComponnetInstance.vnode[COMPONENT_CONTAINER_SYMBOL]);
}
const loadingConstructor = defineComponent(Loading);
const cacheInstance = /* @__PURE__ */ new WeakSet();
const isEmpty = (val) => {
  if (!val) {
    return true;
  }
  if (Array.isArray(val)) {
    return val.length === 0;
  }
  if (val instanceof Set || val instanceof Map) {
    return val.size === 0;
  }
  if (val instanceof Promise) {
    return false;
  }
  if (typeof val === "object") {
    try {
      return Object.keys(val).length === 0;
    } catch (e) {
      return false;
    }
  }
  return false;
};
const getType = (vari) => {
  return Object.prototype.toString.call(vari).slice(8, -1).toLowerCase();
};
const isPromise = (value) => {
  const type = getType(value);
  switch (type) {
    case "promise":
      return [value];
    case "array":
      if (value.some((val) => getType(val) !== "promise")) {
        console.error(new TypeError("Binding values should all be of type Promise"));
        return "error";
      }
      return value;
    default:
      return false;
  }
};
const unmount = (el) => {
  cacheInstance.delete(el);
  el.instance.proxy.close();
  unmountComponent(el.instance);
};
const toggleLoading = (el, binding) => {
  var _a, _b, _c;
  if (binding.value) {
    const vals = isPromise(binding.value);
    if (vals === "error") {
      return;
    }
    (_c = (_b = (_a = el == null ? void 0 : el.instance) == null ? void 0 : _a.proxy) == null ? void 0 : _b.open) == null ? void 0 : _c.call(_b);
    el.appendChild(el.mask);
    cacheInstance.add(el);
    if (vals) {
      Promise.all(vals).catch((err) => {
        console.error(new Error("Promise handling errors"), err);
      }).finally(() => {
        unmount(el);
      });
    }
  } else {
    unmount(el);
  }
};
const removeAttribute = (el) => {
  el.removeAttribute("zindex");
  el.removeAttribute("positiontype");
  el.removeAttribute("backdrop");
  el.removeAttribute("message");
  el.removeAttribute("view");
  el.removeAttribute("loadingtemplateref");
};
const handleProps = (el, vprops) => {
  var _a;
  const props = __spreadValues(__spreadValues({}, new LoadingOptions()), vprops);
  const loadingTemplateRef = props.loadingTemplateRef;
  const loadingInstance = createComponent(loadingConstructor, __spreadValues({}, props), loadingTemplateRef ? () => loadingTemplateRef : null);
  el.style.position = props.positionType || "relative";
  el.options = props;
  el.instance = loadingInstance;
  el.mask = (_a = loadingInstance == null ? void 0 : loadingInstance.proxy) == null ? void 0 : _a.$el;
};
const LoadingDirective = {
  mounted: function(el, binding, vnode) {
    handleProps(el, vnode.props);
    removeAttribute(el);
    !isEmpty(binding.value) && toggleLoading(el, binding);
  },
  updated: function(el, binding, vnode) {
    if (!isEmpty(binding.value) && cacheInstance.has(el) || isEmpty(binding.value) && !cacheInstance.has(el)) {
      return;
    }
    !cacheInstance.has(el) && handleProps(el, vnode.props);
    removeAttribute(el);
    toggleLoading(el, binding);
  }
};
var freeGlobal = typeof global == "object" && global && global.Object === Object && global;
var freeGlobal$1 = freeGlobal;
var freeSelf = typeof self == "object" && self && self.Object === Object && self;
var root = freeGlobal$1 || freeSelf || Function("return this")();
var root$1 = root;
var Symbol$1 = root$1.Symbol;
var Symbol$2 = Symbol$1;
var objectProto$1 = Object.prototype;
var hasOwnProperty = objectProto$1.hasOwnProperty;
var nativeObjectToString$1 = objectProto$1.toString;
var symToStringTag$1 = Symbol$2 ? Symbol$2.toStringTag : void 0;
function getRawTag(value) {
  var isOwn = hasOwnProperty.call(value, symToStringTag$1), tag = value[symToStringTag$1];
  try {
    value[symToStringTag$1] = void 0;
    var unmasked = true;
  } catch (e) {
  }
  var result = nativeObjectToString$1.call(value);
  if (unmasked) {
    if (isOwn) {
      value[symToStringTag$1] = tag;
    } else {
      delete value[symToStringTag$1];
    }
  }
  return result;
}
var objectProto = Object.prototype;
var nativeObjectToString = objectProto.toString;
function objectToString(value) {
  return nativeObjectToString.call(value);
}
var nullTag = "[object Null]", undefinedTag = "[object Undefined]";
var symToStringTag = Symbol$2 ? Symbol$2.toStringTag : void 0;
function baseGetTag(value) {
  if (value == null) {
    return value === void 0 ? undefinedTag : nullTag;
  }
  return symToStringTag && symToStringTag in Object(value) ? getRawTag(value) : objectToString(value);
}
function isObjectLike(value) {
  return value != null && typeof value == "object";
}
var symbolTag = "[object Symbol]";
function isSymbol(value) {
  return typeof value == "symbol" || isObjectLike(value) && baseGetTag(value) == symbolTag;
}
var reWhitespace = /\s/;
function trimmedEndIndex(string) {
  var index2 = string.length;
  while (index2-- && reWhitespace.test(string.charAt(index2))) {
  }
  return index2;
}
var reTrimStart = /^\s+/;
function baseTrim(string) {
  return string ? string.slice(0, trimmedEndIndex(string) + 1).replace(reTrimStart, "") : string;
}
function isObject(value) {
  var type = typeof value;
  return value != null && (type == "object" || type == "function");
}
var NAN = 0 / 0;
var reIsBadHex = /^[-+]0x[0-9a-f]+$/i;
var reIsBinary = /^0b[01]+$/i;
var reIsOctal = /^0o[0-7]+$/i;
var freeParseInt = parseInt;
function toNumber(value) {
  if (typeof value == "number") {
    return value;
  }
  if (isSymbol(value)) {
    return NAN;
  }
  if (isObject(value)) {
    var other = typeof value.valueOf == "function" ? value.valueOf() : value;
    value = isObject(other) ? other + "" : other;
  }
  if (typeof value != "string") {
    return value === 0 ? value : +value;
  }
  value = baseTrim(value);
  var isBinary = reIsBinary.test(value);
  return isBinary || reIsOctal.test(value) ? freeParseInt(value.slice(2), isBinary ? 2 : 8) : reIsBadHex.test(value) ? NAN : +value;
}
var asyncTag = "[object AsyncFunction]", funcTag = "[object Function]", genTag = "[object GeneratorFunction]", proxyTag = "[object Proxy]";
function isFunction(value) {
  if (!isObject(value)) {
    return false;
  }
  var tag = baseGetTag(value);
  return tag == funcTag || tag == genTag || tag == asyncTag || tag == proxyTag;
}
var now = function() {
  return root$1.Date.now();
};
var now$1 = now;
var FUNC_ERROR_TEXT = "Expected a function";
var nativeMax = Math.max, nativeMin = Math.min;
function debounce(func, wait, options) {
  var lastArgs, lastThis, maxWait, result, timerId, lastCallTime, lastInvokeTime = 0, leading = false, maxing = false, trailing = true;
  if (typeof func != "function") {
    throw new TypeError(FUNC_ERROR_TEXT);
  }
  wait = toNumber(wait) || 0;
  if (isObject(options)) {
    leading = !!options.leading;
    maxing = "maxWait" in options;
    maxWait = maxing ? nativeMax(toNumber(options.maxWait) || 0, wait) : maxWait;
    trailing = "trailing" in options ? !!options.trailing : trailing;
  }
  function invokeFunc(time) {
    var args = lastArgs, thisArg = lastThis;
    lastArgs = lastThis = void 0;
    lastInvokeTime = time;
    result = func.apply(thisArg, args);
    return result;
  }
  function leadingEdge(time) {
    lastInvokeTime = time;
    timerId = setTimeout(timerExpired, wait);
    return leading ? invokeFunc(time) : result;
  }
  function remainingWait(time) {
    var timeSinceLastCall = time - lastCallTime, timeSinceLastInvoke = time - lastInvokeTime, timeWaiting = wait - timeSinceLastCall;
    return maxing ? nativeMin(timeWaiting, maxWait - timeSinceLastInvoke) : timeWaiting;
  }
  function shouldInvoke(time) {
    var timeSinceLastCall = time - lastCallTime, timeSinceLastInvoke = time - lastInvokeTime;
    return lastCallTime === void 0 || timeSinceLastCall >= wait || timeSinceLastCall < 0 || maxing && timeSinceLastInvoke >= maxWait;
  }
  function timerExpired() {
    var time = now$1();
    if (shouldInvoke(time)) {
      return trailingEdge(time);
    }
    timerId = setTimeout(timerExpired, remainingWait(time));
  }
  function trailingEdge(time) {
    timerId = void 0;
    if (trailing && lastArgs) {
      return invokeFunc(time);
    }
    lastArgs = lastThis = void 0;
    return result;
  }
  function cancel() {
    if (timerId !== void 0) {
      clearTimeout(timerId);
    }
    lastInvokeTime = 0;
    lastArgs = lastCallTime = lastThis = timerId = void 0;
  }
  function flush() {
    return timerId === void 0 ? result : trailingEdge(now$1());
  }
  function debounced() {
    var time = now$1(), isInvoking = shouldInvoke(time);
    lastArgs = arguments;
    lastThis = this;
    lastCallTime = time;
    if (isInvoking) {
      if (timerId === void 0) {
        return leadingEdge(lastCallTime);
      }
      if (maxing) {
        clearTimeout(timerId);
        timerId = setTimeout(timerExpired, wait);
        return invokeFunc(lastCallTime);
      }
    }
    if (timerId === void 0) {
      timerId = setTimeout(timerExpired, wait);
    }
    return result;
  }
  debounced.cancel = cancel;
  debounced.flush = flush;
  return debounced;
}
function isNil(value) {
  return value == null;
}
var Dropdown = defineComponent({
  name: "DEditableSelectDropdown",
  directives: {
    Loading: LoadingDirective
  },
  props: dropdownProps,
  setup(props, {
    slots
  }) {
    const ns = useNamespace("editable-select");
    const {
      width,
      maxHeight
    } = toRefs(props);
    const select = inject(SELECT_KEY);
    const {
      dropdownRef,
      hoveringIndex,
      handleOptionSelect,
      loadMore,
      emptyText
    } = select;
    const isHovering = (index2) => {
      return hoveringIndex.value === index2;
    };
    const isDisabled = (option) => {
      return select.disabledKey ? !!option[select.disabledKey] : false;
    };
    const debounceLoadMore = debounce(loadMore, 300);
    const onScroll = () => {
      debounceLoadMore();
    };
    const renderOption = () => {
      if (props.options.length === 0) {
        return createVNode("li", {
          "class": ns.em("item", "no-data-tip")
        }, [slots.noResultItem ? slots.noResultItem() : emptyText.value]);
      }
      return props.options.map((option, index2) => {
        return createVNode(Option, {
          "label": option.label,
          "value": option.value,
          "hovering": isHovering(index2),
          "disabled": isDisabled(option),
          "onSelect": () => {
            handleOptionSelect(option, true);
          }
        }, slots.item ? {
          default: () => renderSlot(useSlots(), "item", {
            option,
            index: index2
          })
        } : {});
      });
    };
    return () => {
      return withDirectives(createVNode("div", {
        "class": ns.e("dropdown"),
        "style": {
          width: `${width == null ? void 0 : width.value}px`
        }
      }, [createVNode("div", {
        "ref": dropdownRef,
        "class": ns.e("inner"),
        "style": {
          maxHeight: `${maxHeight == null ? void 0 : maxHeight.value}px`
        },
        "onScroll": onScroll
      }, [renderOption()])]), [[resolveDirective("loading"), select.loading.value]]);
    };
  }
});
function deepAssign(...objects) {
  const isObject2 = (obj) => obj && typeof obj === "object";
  return objects.reduce((prev, from) => {
    Object.keys(from).forEach((key) => {
      const pVal = prev[key];
      const oVal = from[key];
      if (Array.isArray(pVal) && Array.isArray(oVal)) {
        prev[key] = Array.from(/* @__PURE__ */ new Set([...oVal, ...pVal]));
      } else if (isObject2(pVal) && isObject2(oVal)) {
        prev[key] = deepAssign(pVal, oVal);
      } else {
        prev[key] = oVal;
      }
    });
    return prev;
  }, {});
}
var zhCN = {
  pagination: {
    totalItemText: "\u6240\u6709\u6761\u76EE",
    goToText: "\u8DF3\u81F3",
    perPage: "\u6761/\u9875"
  },
  accordion: {
    loading: "\u52A0\u8F7D\u4E2D",
    noData: "\u6CA1\u6709\u6570\u636E"
  },
  autoCompleteDropdown: {
    latestInput: "\u6700\u8FD1\u8F93\u5165"
  },
  cascaderList: {
    noData: "\u6CA1\u6709\u6570\u636E"
  },
  colorPicker: {
    foundationPanel: "\u57FA\u7840\u9762\u677F",
    advancedPanel: "\u9AD8\u7EA7\u9762\u677F"
  },
  datePickerPro: {
    ok: "\u786E\u5B9A",
    placeholder: "\u8BF7\u9009\u62E9\u65E5\u671F",
    month1: "1\u6708",
    month2: "2\u6708",
    month3: "3\u6708",
    month4: "4\u6708",
    month5: "5\u6708",
    month6: "6\u6708",
    month7: "7\u6708",
    month8: "8\u6708",
    month9: "9\u6708",
    month10: "10\u6708",
    month11: "11\u6708",
    month12: "12\u6708",
    year: "\u5E74",
    startPlaceholder: "\u8BF7\u9009\u62E9\u5F00\u59CB\u65E5\u671F",
    endPlaceholder: "\u8BF7\u9009\u62E9\u7ED3\u675F\u65E5\u671F",
    getWeekDays() {
      return ["\u65E5", "\u4E00", "\u4E8C", "\u4E09", "\u56DB", "\u4E94", "\u516D"];
    },
    getTimeArr() {
      return ["\u65F6", "\u5206", "\u79D2"];
    },
    getYearMonthStr(year, month) {
      return `${year}\u5E74${month}\u6708`;
    }
  },
  editableSelect: {
    noRelatedRecords: "\u627E\u4E0D\u5230\u76F8\u5173\u8BB0\u5F55",
    noData: "\u6CA1\u6709\u6570\u636E"
  },
  input: {
    placeholder: "\u8BF7\u8F93\u5165"
  },
  splitterBar: {
    collapse: "\u6536\u8D77",
    expand: "\u5C55\u5F00"
  },
  stepsGuide: {
    previous: "\u4E0A\u4E00\u6B65",
    continue: "\u6211\u77E5\u9053\u5566\uFF0C\u7EE7\u7EED",
    ok: "\u6211\u77E5\u9053\u5566"
  },
  table: {
    selectAll: "\u5168\u9009",
    ok: "\u786E\u5B9A"
  },
  timePopup: {
    ok: "\u786E\u5B9A"
  },
  transfer: {
    unit: "\u9879",
    panelUnit: "\u9879",
    headerUnit: "\u9879",
    noData: "\u6682\u65E0\u6570\u636E",
    placeholder: "\u8BF7\u8F93\u5165\u5173\u952E\u8BCD\u641C\u7D22"
  },
  tree: {
    loading: "\u52A0\u8F7D\u4E2D",
    newNode: "\u65B0\u8282\u70B9",
    selectPlaceholder: "\u8BF7\u9009\u62E9"
  },
  upload: {
    placeholder: "\u9009\u62E9\u6587\u4EF6",
    getExistSameNameFilesMsg(sameNames) {
      return `\u60A8\u4E0A\u4F20\u7684 "${sameNames}" \u5B58\u5728\u91CD\u540D\u6587\u4EF6, \u8BF7\u91CD\u65B0\u9009\u62E9\u6587\u4EF6`;
    },
    getAllFilesBeyondMaximalFileSizeMsg(maximalSize) {
      return `\u6700\u5927\u652F\u6301\u4E0A\u4F20${maximalSize}MB\u7684\u6587\u4EF6, \u60A8\u672C\u6B21\u4E0A\u4F20\u7684\u6240\u6709\u6587\u4EF6\u8D85\u8FC7\u53EF\u4E0A\u4F20\u6587\u4EF6\u5927\u5C0F`;
    },
    getBeyondMaximalFileSizeMsg(filename, maximalSize) {
      return `\u6700\u5927\u652F\u6301\u4E0A\u4F20${maximalSize}MB\u7684\u6587\u4EF6, \u60A8\u4E0A\u4F20\u7684\u6587\u4EF6"${filename}"\u8D85\u8FC7\u53EF\u4E0A\u4F20\u6587\u4EF6\u5927\u5C0F`;
    },
    getNotAllowedFileTypeMsg(filename, scope) {
      return `\u652F\u6301\u7684\u6587\u4EF6\u7C7B\u578B: "${scope}", \u60A8\u4E0A\u4F20\u7684\u6587\u4EF6"${filename}"\u4E0D\u5728\u5141\u8BB8\u8303\u56F4\u5185\uFF0C\u8BF7\u91CD\u65B0\u9009\u62E9\u6587\u4EF6`;
    }
  },
  search: {
    placeholder: "\u8BF7\u8F93\u5165\u5173\u952E\u5B57"
  },
  select: {
    placeholder: "\u8BF7\u9009\u62E9",
    noDataText: "\u65E0\u6570\u636E",
    noMatchText: "\u627E\u4E0D\u5230\u76F8\u5173\u8BB0\u5F55",
    loadingText: "\u52A0\u8F7D\u4E2D..."
  },
  tagInput: {
    maxTagsText: "\u5DF2\u8FBE\u5230\u6700\u5927\u4E2A\u6570\uFF1A"
  },
  timeSelect: {
    placeholder: "\u8BF7\u9009\u62E9\u65F6\u95F4"
  }
};
const lang = ref("zh-CN");
let langMessages = reactive({
  [lang.value]: zhCN
});
const Locale = {
  messages() {
    return langMessages[lang.value];
  },
  lang() {
    return lang.value;
  },
  use(newLang, newMessages) {
    lang.value = newLang;
    this.add({ [newLang]: newMessages });
  },
  add(newMessages = {}) {
    langMessages = deepAssign(langMessages, newMessages);
  }
};
const camelize = (name) => name.substring(1).replace(/^\S/, (s) => s.toLocaleLowerCase());
function get(object, path) {
  const keys = path.split(".");
  let result = object;
  keys.forEach((key) => {
    var _a;
    result = (_a = result[key]) != null ? _a : "";
  });
  return result;
}
function createI18nTranslate(name, app, newPrefix) {
  const prefix = newPrefix || camelize(name) + ".";
  return (path) => {
    var _a;
    const messages = ((_a = app == null ? void 0 : app.appContext.config.globalProperties.langMessages) == null ? void 0 : _a.value) || Locale.messages();
    const message = get(messages, prefix + path) || get(messages, path);
    return message;
  };
}
function useSelectStates() {
  return reactive({
    hoveringIndex: -1,
    selectedIndex: -1,
    query: "",
    inputValue: "",
    selectedLabel: "",
    isFocus: false,
    visible: false,
    softFocus: false,
    isSilentBlur: false,
    inputHovering: false
  });
}
function useSelect(dropdownRef, props, states, setSoftFocus, ctx) {
  const app = getCurrentInstance();
  const t = createI18nTranslate("DEditableSelect", app);
  const cachedOptions = ref(props.options);
  const filteredOptions = computed(() => {
    return cachedOptions.value.filter((option) => {
      return option.label.toLocaleLowerCase().includes(states.query.toLocaleLowerCase().trim());
    });
  });
  const emptyText = computed(() => {
    let text = "";
    props.remote ? text = t("noData") : text = t("noRelatedRecords");
    return text;
  });
  const showClearable = computed(() => {
    const hasModelValue = !isNil(props.modelValue) && props.modelValue !== "";
    return props.allowClear && !props.disabled && states.inputHovering && hasModelValue;
  });
  const toggleMenu = () => {
    if (!props.disabled) {
      states.visible = !states.visible;
    }
  };
  const updateIndex = (index2) => {
    states.hoveringIndex = index2;
    states.selectedIndex = index2;
  };
  const setSelected = () => {
    const options = cachedOptions.value;
    if (!isNil(props.modelValue)) {
      const index2 = options.findIndex((option) => option.value === props.modelValue);
      if (index2 !== -1) {
        states.inputValue = options[index2].label;
        states.selectedLabel = options[index2].label;
        updateIndex(index2);
      } else {
        states.inputValue = `${props.modelValue}`;
        states.selectedLabel = `${props.modelValue}`;
      }
    } else {
      states.inputValue = "";
    }
  };
  const handleOptionSelect = (option, byClick) => {
    ctx.emit("update:modelValue", option.value);
    ctx.emit("change", option.value);
    states.isSilentBlur = byClick;
    setSoftFocus();
    states.visible = false;
  };
  const scrollToItem = (idx) => {
    const ul = dropdownRef.value;
    const li = ul.children[idx];
    nextTick(() => {
      if (li.scrollIntoViewIfNeeded) {
        li.scrollIntoViewIfNeeded(false);
      } else {
        const containerInfo = ul.getBoundingClientRect();
        const elementInfo = li.getBoundingClientRect();
        if (elementInfo.bottom > containerInfo.bottom || elementInfo.top < containerInfo.top) {
          li.scrollIntoView(false);
        }
      }
    });
  };
  watch(() => states.visible, (visible) => {
    if (visible) {
      states.selectedIndex !== -1 && nextTick(() => {
        scrollToItem(states.selectedIndex);
      });
    } else {
      states.query = "";
      states.inputValue = states.selectedLabel;
    }
    ctx.emit("visibleChange", visible);
  });
  watch(() => props.modelValue, () => {
    setSelected();
  });
  watch(() => props.options, (newOptions) => {
    if (newOptions.length !== 0) {
      cachedOptions.value = newOptions;
    }
  });
  onMounted(() => {
    setSelected();
  });
  return {
    cachedOptions,
    filteredOptions,
    emptyText,
    showClearable,
    toggleMenu,
    handleOptionSelect,
    scrollToItem
  };
}
const EVENT_CODE = {
  tab: "Tab",
  enter: "Enter",
  up: "ArrowUp",
  down: "ArrowDown",
  esc: "Escape"
};
function useKeyboardSelect(props, states, filteredOptions, scrollToItem, handleOptionSelect) {
  const updateHoveringIndex = (index2) => {
    states.hoveringIndex = index2;
  };
  const onKeyboardNavigate = (direction, hoverIndex = states.hoveringIndex) => {
    if (!states.visible) {
      states.visible = true;
      return;
    }
    if (filteredOptions.value.length === 0 || props.loading) {
      return;
    }
    let newIndex = 0;
    if (direction === "ArrowDown") {
      newIndex = hoverIndex + 1;
      if (newIndex > filteredOptions.value.length - 1) {
        newIndex = 0;
      }
    } else if (direction === "ArrowUp") {
      newIndex = hoverIndex - 1;
      if (newIndex < 0) {
        newIndex = filteredOptions.value.length - 1;
      }
    }
    const option = filteredOptions.value[newIndex];
    if (option[props.disabledKey]) {
      return onKeyboardNavigate(direction, newIndex);
    } else {
      updateHoveringIndex(newIndex);
      scrollToItem(newIndex);
    }
  };
  const onEscOrTab = () => {
    states.visible = false;
  };
  const onKeyboardSelect = () => {
    if (!states.visible) {
      return states.visible = true;
    }
    const option = filteredOptions.value[states.hoveringIndex];
    if (option) {
      handleOptionSelect(option, false);
    }
  };
  const onKeydown = (e) => {
    const keyCode = e.key || e.code;
    const { tab, esc, down, up, enter } = EVENT_CODE;
    if (keyCode === up || keyCode === down) {
      e.preventDefault();
    }
    switch (keyCode) {
      case up:
        onKeyboardNavigate("ArrowUp");
        break;
      case down:
        onKeyboardNavigate("ArrowDown");
        break;
      case esc:
      case tab:
        onEscOrTab();
        break;
      case enter:
        onKeyboardSelect();
        break;
    }
  };
  return {
    onKeydown
  };
}
function useInputRender(props, states) {
  const ns = useNamespace("editable-select-input");
  const inputClasses = computed(() => ({
    [ns.b()]: true,
    [ns.m("sm")]: props.size === "sm",
    [ns.m("lg")]: props.size === "lg",
    [ns.m("open")]: states.visible
  }));
  const inputWrapperClasses = computed(() => ({
    [ns.e("wrapper")]: true,
    [ns.em("wrapper", "focus")]: states.isFocus,
    [ns.em("wrapper", "disabled")]: props.disabled
  }));
  const inputInnerClasses = computed(() => ({
    [ns.e("inner")]: true
  }));
  const inputPlaceholderClasses = computed(() => ({
    [ns.e("placeholder")]: true
  }));
  const inputSuffixClasses = computed(() => ({
    [ns.e("suffix")]: true
  }));
  return {
    inputClasses,
    inputWrapperClasses,
    inputInnerClasses,
    inputPlaceholderClasses,
    inputSuffixClasses
  };
}
function useInputEvent(inputRef, props, states, ctx) {
  const delay = computed(() => props.remote ? 300 : 0);
  const setSoftFocus = () => {
    var _a;
    const _input = inputRef.value;
    if (_input) {
      (_a = _input.focus) == null ? void 0 : _a.call(_input);
    }
  };
  const handleFocus = (e) => {
    if (!states.softFocus) {
      ctx.emit("focus", e);
      states.isFocus = true;
    } else {
      states.softFocus = false;
    }
  };
  const handleBlur = async (e) => {
    if (states.isSilentBlur) {
      states.isSilentBlur = false;
    } else {
      ctx.emit("blur", e);
      states.isFocus = true;
    }
    states.softFocus = false;
  };
  const updateInputValue = (value) => {
    states.inputValue = value;
  };
  const handleQueryChange = (value) => {
    if (props.remote && isFunction(props.remoteMethod)) {
      props.remoteMethod(value);
    } else if (isFunction(props.filterMethod)) {
      props.filterMethod(value);
    }
  };
  const handleInputChange = () => {
    states.query = states.inputValue;
    handleQueryChange(states.query);
  };
  const debouncedOnInputChange = debounce(handleInputChange, delay.value);
  const onInput = (e) => {
    const value = e.target.value;
    updateInputValue(value);
    if (states.inputValue.length > 0 && !states.visible) {
      states.visible = true;
    }
    if (props.remote) {
      debouncedOnInputChange();
    } else {
      handleInputChange();
    }
  };
  const onMouseenter = () => {
    states.inputHovering = true;
  };
  const onMouseleave = () => {
    states.inputHovering = false;
  };
  const handleClear = () => {
    ctx.emit("update:modelValue", "");
    ctx.emit("change", "");
    ctx.emit("clear");
    states.hoveringIndex = -1;
    states.visible = false;
  };
  return {
    blur,
    setSoftFocus,
    handleFocus,
    handleBlur,
    handleClear,
    onInput,
    onMouseenter,
    onMouseleave
  };
}
function useLazyLoad(dropdownRef, props, ctx) {
  const { enableLazyLoad } = toRefs(props);
  const loadMore = () => {
    if (!dropdownRef.value || !enableLazyLoad.value) {
      return;
    }
    if ((dropdownRef == null ? void 0 : dropdownRef.value.clientHeight) + dropdownRef.value.scrollTop >= dropdownRef.value.scrollHeight - 12) {
      ctx.emit("loadMore");
    }
  };
  return { loadMore };
}
var editableSelect = "";
function _isSlot(s) {
  return typeof s === "function" || Object.prototype.toString.call(s) === "[object Object]" && !isVNode(s);
}
var EditableSelect = defineComponent({
  name: "DEditableSelect",
  props: editableSelectProps,
  emits: ["update:modelValue", "focus", "blur", "clear", "change", "visibleChange", "loadMore"],
  setup(props, ctx) {
    const ns = useNamespace("editable-select");
    const inputRef = ref();
    const originRef = ref();
    const dropdownRef = ref();
    const overlayRef = ref();
    const states = useSelectStates();
    const {
      appendToBody,
      disabled,
      modelValue,
      position,
      placeholder
    } = toRefs(props);
    const {
      onInput,
      onMouseenter,
      onMouseleave,
      setSoftFocus,
      handleBlur,
      handleFocus,
      handleClear
    } = useInputEvent(inputRef, props, states, ctx);
    const {
      filteredOptions,
      emptyText,
      showClearable,
      toggleMenu,
      handleOptionSelect,
      scrollToItem
    } = useSelect(dropdownRef, props, states, setSoftFocus, ctx);
    const {
      onKeydown
    } = useKeyboardSelect(props, states, filteredOptions, scrollToItem, handleOptionSelect);
    const {
      loadMore
    } = useLazyLoad(dropdownRef, props, ctx);
    provide(SELECT_KEY, {
      dropdownRef,
      disabledKey: props.disabledKey,
      modelValue,
      inputValue: toRef(states, "inputValue"),
      query: toRef(states, "query"),
      hoveringIndex: toRef(states, "hoveringIndex"),
      loading: toRef(props, "loading"),
      emptyText,
      loadMore,
      handleOptionSelect,
      setSoftFocus
    });
    onClickOutside(originRef, () => {
      states.visible = false;
      states.isFocus = false;
    }, {
      ignore: [overlayRef]
    });
    const {
      inputClasses,
      inputWrapperClasses,
      inputInnerClasses,
      inputSuffixClasses
    } = useInputRender(props, states);
    const renderBasicDropdown = () => {
      return createVNode(Transition, {
        "name": "fade"
      }, {
        default: () => [createVNode(FlexibleOverlay, {
          "ref": overlayRef,
          "modelValue": states.visible,
          "onUpdate:modelValue": ($event) => states.visible = $event,
          "origin": originRef.value,
          "position": position.value,
          "style": {
            zIndex: "var(--devui-z-index-dropdown, 1052)"
          }
        }, {
          default: () => [createVNode(Dropdown, {
            "options": filteredOptions.value,
            "width": props.width,
            "maxHeight": props.maxHeight
          }, ctx.slots)]
        })]
      });
    };
    const renderDropdown = () => {
      if (appendToBody.value) {
        let _slot;
        return createVNode(Teleport, {
          "to": "body"
        }, _isSlot(_slot = renderBasicDropdown()) ? _slot : {
          default: () => [_slot]
        });
      } else {
        return renderBasicDropdown();
      }
    };
    return () => {
      return createVNode("div", {
        "ref": originRef,
        "class": ns.b(),
        "style": {
          width: props.width + "px"
        },
        "onClick": toggleMenu
      }, [createVNode("div", {
        "class": inputClasses.value,
        "onMouseenter": onMouseenter,
        "onMouseleave": onMouseleave
      }, [createVNode("div", {
        "class": inputWrapperClasses.value
      }, [createVNode("input", {
        "ref": inputRef,
        "class": inputInnerClasses.value,
        "disabled": disabled.value,
        "placeholder": placeholder.value,
        "value": states.inputValue,
        "type": "text",
        "onInput": onInput,
        "onFocus": handleFocus,
        "onBlur": handleBlur,
        "onKeydown": onKeydown
      }, null), createVNode("span", {
        "class": inputSuffixClasses.value
      }, [withDirectives(createVNode("span", {
        "class": ns.e("clear-icon"),
        "onClick": withModifiers(handleClear, ["stop"])
      }, [createVNode(Icon, {
        "name": "icon-remove"
      }, null)]), [[vShow, showClearable.value]]), withDirectives(createVNode("span", {
        "class": ns.e("arrow-icon")
      }, [createVNode(Icon, {
        "name": "select-arrow"
      }, null)]), [[vShow, !showClearable.value]])])])]), renderDropdown()]);
    };
  }
});
var index = {
  title: "EditableSelect \u53EF\u8F93\u5165\u4E0B\u62C9\u9009\u62E9\u6846",
  category: "\u6570\u636E\u5F55\u5165",
  status: "100%",
  install(app) {
    app.component(EditableSelect.name, EditableSelect);
  }
};
export { EditableSelect, SELECT_KEY, index as default, editableSelectProps };
